#ifndef BINTREE_H
#define BINTREE_H

#include <iostream>
#include <fstream>
#include <string>
#include "eidpliste.h"

using namespace std;

template<typename T>
class BinTree {
    struct Node {
	T data; // Inhalt des Knoten
	Node *left = nullptr; // linker Unterbaum
	Node *right = nullptr; // rechter Unterbaum
    };
    
public:
    BinTree() = default;
    
    ~BinTree() {
	clear(root);
    }
    
    void clear() {
	clear(root);
	root = nullptr;
    }
    
    void insert(T const &x) {
	root = insert(root, x);
    }
    
    bool isElement(T const &x) const {
	return isElement(root, x);
    }
    
    T const &rootData() const {
	return root->data;
    }
    
    void preOrder() const {
	Liste<T> liste;
	preOrder(root);
	cout << endl;
    }
    
    int height() const {
	return height(root);
    }
    
    int count() const {
	return count(root);
    }
    
    void range(T const &min, T const &max) const {
	range(root, min, max);
    }
    
    void rotateLeft();

private:
    void preOrder(Node const *node) const {
	if (node == nullptr) return;
	cout << node->data << " ";
	preOrder(node->left);
	preOrder(node->right);
    }

    bool isElement(Node *node, T data) {
	if (node == nullptr) return false;
	if (node->data == data) return true;
	if (node->data < data) return isElement(node->right, data);
	return isElement(node->left, data);
    }
    
    void clear(Node *node) {
	if (node == nullptr) return;
	clear(node->left);
	clear(node->right);
	delete node;
    }
    
    Node *insert(Node *node, T data) {
	if (node == nullptr) {
	    node = new Node;
	    node->data = data;
	    return node;
	}
	if (node->data < data)
	    node->right = insert(node->right, data);
	else if (node->data > data)
	    node->left = insert(node->left, data);
	return node;
    }

    // Aufgabe a)
    int height(Node *node) const {
	// hier Code einfuegen
	return 0;
    }
    
    void range(Node const *node, T const &min, T const &max) const;
    
    Node *root = nullptr; // Wurzel
};

// Aufgabe b)
template<typename T>
void BinTree<T>::range(Node const *node, T const &min, T const &max) const {
    // hier Code einfuegen
}

// Aufgabe c)
template<typename T>
void BinTree<T>::rotateLeft() {
    // hier Code einfuegen
}

#endif /* BINTREE_H */
